---
id: terraform
title: "Terraform,  what is it and how is it used in this project?"
sidebar_label: "Using Terraform"
slug: /terraform
---

Terraform is an [IAC](../portofolio/iac) tool, and it is used for the **implementation** of the POC. The entire project's concept is to create an environment
automatically through code which in turn would make it more **secure and more manageable**. To understand why exactly that is, this
chapter will go into detail on how this is done in the project by looking at the different **components of terraform** and how they
function in **relationship with this project**.

![img](../../static/img/Terraform_Architecture.png)
Figure 1 - Terraform deployment architerture

--------------------

As seen in figure 1, Terraform creates resources by using its **own libraries** of custom-made provider implementations, and its **custom-made provisioning tools**.
At the same time, client implementation uses the libraries provided by the **providers SDKs**, and then, through the representative API of the provider, Terraform triggers the
creation of the resources that are **declared in its scripts**. To better understand how scripts work continues reading.

![img](../../static/img/terraformtf.png)
Figure 2 - Files used for deployment

---------------------------

To create resources in Terraform you need  ```.tf``` files, these are the **resource building files** and are the ones based on which
Terraform will **deploy the resources**. There are a great number of resources that can be created and some are dependent on others,
therefore when **building a virtual machine**, you don’t only **need** a virtual machine but also, a **NIC** (network interface card) for the
virtual machine, a **resource group** where to deploy it, a **subnet for it to run on**, and **credentials** for the virtual machine.

As you can imagine, whenever there are **credentials involved** in the deployment of machines, there is
a **possibility for them to be leaked**, posing a **security risk**. Therefore, whenever passing passwords, tokens, credential keys, or
any other form of credentials it is **recommended to use variables**.
 

![img](../../static/img/terraformVariables.png)
Figure 3 - Files used for defining credentials 

--------------------------------

There are **3 types of variables** that can be declared, **global**, **local** variables, **command-line** variables, just like in any other
programming language or more exactly **configuration language**. For **local variables**, you can only give the value to the variable
in the **local file** and it is recommended to be used for **passing strings** like storing names of resources,
lists of values or IPs, etc.  **Global variables** are different, they can be declared in **any files**, preferably in a different one for
ease of use and to **make the code easy to read**. After being declared, passing the values to the variables themselves uses
**3 methods**, either through **environment variables** that need to start with ```TF_VAR_name ``` or by giving them a value in a
**separate file** that has a “.tfvar” extension or by **passing them directly** at the **apply stage**.

For the purposes of the project and the ease of use the method used was the passing of variables through a  **.tfvar file**, because variables do
not need to be set every time. When deploying terraformed code, you want to ensure that it can be **automated through** the **CI/CD
pipeline** so that all runs are **visible and can be tracked down** in order to **easily monitor** the changes and **the results**.

After **setting the variables** and declaring all the **resources** correctly which is best verified by using ```terraform validate```,
deploying the infrastructure is made extremely easy by **importing all the provider resources** ``terraform init`` and then deploying
through  ```terraform apply -var-file=varfile.tfvars```(variable values can also be passed through ``-var=var1,var2,var3`` but
this is a more strenuous and less maintainable solution ).

-------------------------------
Code Section 1 - Example of plan results (planing is used preapplies to visualize the changes)

---------------------------

```

An execution plan has been generated and is shown below.
Resource actions are indicated with the following symbols:
  ~ update in-place
-/+ destroy and then create replacement

Terraform will perform the following actions:

  \# azurerm_linux_virtual_machine.vm must be replaced
-/+ resource "azurerm_linux_virtual_machine" "vm" {
        admin_password                  = (sensitive value)
        admin_username                  = "\[redacted\]"
        allow_extension_operations      = true
      ~ computer_name                   = "\[redacted\]" -> (known after apply)
      ~ custom_data                     = (sensitive value)
        disable_password_authentication = true
      ~ id                              = "/subscriptions/\[redacted\]/resourceGroups/\[redacted\]/providers/Microsoft.Compute/virtualMachines/RavenMain" -> (known after apply)
        location                        = "\[redacted\]"
        max_bid_price                   = -1
        name                            = "\[redacted\]"
        network_interface_ids           = [
            "/subscriptions/\[redacted\]/resourceGroups/\[redacted\]/providers/Microsoft.Network/networkInterfaces/NIC",
        ]
        priority                        = "Regular"
      ~ private_ip_address              = "\[redacted\]" -> (known after apply)
      ~ private_ip_addresses            = [
          - "10.0.2.4",
        ] -> (known after apply)
        provision_vm_agent              = true
      ~ public_ip_address               = "\[redacted\]" -> (known after apply)
      ~ public_ip_addresses             = [
          - "20.52.137.77",
        ] -> (known after apply)
        resource_group_name             = "\[redacted\]"
        size                            = "Standard_B1s"
        source_image_id                 = "/subscriptions/\[redacted\]/resourceGroups/ConsulClusterDTACT/providers/Microsoft.Compute/images/\[redacted\]"
      - tags                            = {} -> null
      ~ virtual_machine_id              = "\[redacted\]" -> (known after apply)

        admin_ssh_key {
            public_key = "\[redacted\]"
            username   = "\[redacted\]"
        }

      ~ os_disk {
            caching                   = "ReadWrite"
          ~ disk_size_gb              = 30 -> (known after apply)
            name                      = "\[redacted\]"
            storage_account_type      = "Standard_LRS"
            write_accelerator_enabled = false
        }
    }

  \# azurerm_linux_virtual_machine.vm_docker must be replaced
-/+ resource "azurerm_linux_virtual_machine" "vm_docker" {
        admin_password                  = (sensitive value)
        admin_username                  = "\[redacted\]"
        allow_extension_operations      = true
      ~ computer_name                   = "\[redacted\]" -> (known after apply)
      ~ custom_data                     = (sensitive value)
        disable_password_authentication = true
      ~ id                              = "/subscriptions/\[redacted\]/resourceGroups/\[redacted\]/providers/Microsoft.Compute/virtualMachines/RavenDockerMachine" -> (known after apply)
        location                        = "\[redacted\]"
        max_bid_price                   = -1
        name                            = "\[redacted\]"
        network_interface_ids           = [
            "/subscriptions/\[redacted\]/resourceGroups/\[redacted\]/providers/Microsoft.Network/networkInterfaces/NIC_docker",
        ]
        priority                        = "Regular"
      ~ private_ip_address              = "\[redacted\]" -> (known after apply)
      ~ private_ip_addresses            = [
          - "\[redacted\]",
        ] -> (known after apply)
        provision_vm_agent              = true
      ~ public_ip_address               = "\[redacted\]" -> (known after apply)
      ~ public_ip_addresses             = [
          - "\[redacted\]",
        ] -> (known after apply)
        resource_group_name             = "\[redacted\]"
        size                            = "Standard_B1s"
        source_image_id                 = "/subscriptions/\[redacted\]/resourceGroups/ConsulClusterDTACT/providers/Microsoft.Compute/images/\[redacted\]"
      - tags                            = {} -> null
      ~ virtual_machine_id              = "\[redacted\]" -> (known after apply)

        admin_ssh_key {
            public_key = "\[redacted\]"
            username   = "\[redacted\]"
        }

      ~ os_disk {
            caching                   = "ReadWrite"
          ~ disk_size_gb              = 30 -> (known after apply)
            name                      = "\[redacted\]"
            storage_account_type      = "Standard_LRS"
            write_accelerator_enabled = false
        }
    }

  \# module.db-maria.azurerm_mariadb_firewall_rule.mariadb_fw_rule["rule1"] will be updated in-place
  ~ resource "azurerm_mariadb_firewall_rule" "mariadb_fw_rule" {
      ~ end_ip_address      = "\[redacted\]" -> "\[redacted\]"
        id                  = "/subscriptions/\[redacted\]/resourceGroups/\[redacted\]/providers/Microsoft.\[redacted\]/servers/ci-test-gwc-development-mariadb/firewallRules/rule1"
        name                = "rule1"
        resource_group_name = "\[redacted\]"
        server_name         = "\[redacted\]"
        start_ip_address    = "\[redacted\]"
    }

Plan: 2 to add, 1 to change, 2 to destroy.

Warning: "address_prefix": [DEPRECATED] Use the `address_prefixes` property instead.

  on possible.tf line 124, in resource "azurerm_subnet" "internal":
 124: resource "azurerm_subnet" "internal" {

(and one more similar warning elsewhere)

```

-------------------------------
Code Section 1 - Example of plan results (planing used preapplies to visualize the changes)

---------------------------

As it can be seen from this deploy most of the information that is created during a deploy **should be kept safe** because it can be used
for **malicious purposes** by giving away the very infrastrucutre and the **inner workings of an evironment**. But if a deployment is compromised
there is **a solution** that will be mentioned shortly.


Once the `terraform apply` command is executed, a **list of all resources** that will be created is displayed and the **relationship between them** as seen in code section 1.
In addition, to pass values from one machine to another the **output.tf file** can be used, where the output of a module or a resource can be declared.
Afterwards, if the **credentials supplied** are correct, the code is functional and the **provider is up**, the **code is executed** starting and
creating the resources in the correct order as assured by Terraform.

Finally, if there is a problem, such as a **compromised machine**, **manually misconfiguration** or **malware** in the infrastructure everything
can be **destroyed** through a simple command ``terraform destroy -var-file=varfile.tfvars``. As you can see its **easy** to **deploy**, eventually **destroy**,
and then **redeploy** an entire infrastructure **without being affected** by the **complexity** of the cloud infrastructure developed by administrators.

### Conclusion

Based on its merits, Terraform is the IAC tool used in this project because it can be used to manage and secure the needed infrastructure.

Moreover, Terraform can securely pass and use credentials to create resources, which is an important requirement for any security project.
